﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace czolg_1
{
    internal class Czolg
    {
        int[] klatki = new int[4];
        static float maxV = 2.0f;
        private int idKlatka;
        private int wiersz,kolumna;//pozycja w klatkach swiata gry
        private int wys, szer;//wysokośc i szerokośc klatki świata gry
        private float x, y;//pozycja we współrzednych ekranowych
        public float v = maxV;//predkosc
        public bool fRuch = false;
        
        
        
        public int Wiersz
        {//zwroc,ustaw pozycje w klatkach swiata gry 
            get { return wiersz; }
            set { wiersz = value; }
        }
        public int Kolumna
        {//zwroc,ustaw pozycje w klatkach swiata gry 
            get { return kolumna; }
            set { kolumna = value; }
        }
        //funkcja odczytu max predkosci
        public float Vmax { get { return maxV; } }
        //zwróć wpsółrzędne obiektu ze świata gry
        public float X { get { return x; } }
        public float Y { get { return y; } }
        //zwróc klatke kierunku ruchu, potrzebne do strzelania
        public byte IdKlatka { get { return (byte)idKlatka; } }
        //konstruktor
        public Czolg(int _idKlatka,int _wiersz,int _kolumna,int _wys,int _szer)
        {
            idKlatka = _idKlatka;
            Wiersz = _wiersz;
            Kolumna = _kolumna; 
            wys =_wys;
            szer = _szer;
            //oblicz współrzedne startu
            x = Kolumna * szer + szer/2;
            y = Wiersz * wys + wys/2;
        }

        public void LadujKlatkiKierunku(int _N,int _E,int _S,int _W)
        {
            klatki[0] = _N;//na północ
            klatki[1] = _E;//na wschód
            klatki[2] = _S;//na południe
            klatki[3] = _W;//na zachód
        }

        public void Rysuj(Graphics g, List<Bitmap> bmp)
        {
            g.DrawImage(bmp[klatki[idKlatka]],
                        new Rectangle((int)x-szer/2, (int)y-wys/2, szer, wys),
                        new Rectangle(0, 0, szer, wys),
                        GraphicsUnit.Pixel);
        }

        public void Obracaj(int i)
        {
            idKlatka += i;
            if (idKlatka < 0) idKlatka = 3;
            if (idKlatka > 3) idKlatka = 0;
        }
        private bool CzyMoznaZrobicRuch(int[,] plansza,int ileKlatekX,int ileKlatekY,Czolg B)
        {
            //tymczasowe współrzędne położenia
            float _x = x,
                  _y = y;
            //sprawdzaj możliwośc ruchu z dokładnością
            //do osmiokrotnego przesunięcia pozycji
            //wartośc nalezy dopasowac do obrysu duszka względem
            //pełengo rozmiaru klatki
            switch (idKlatka)
            {
                //na północ
                case 0: _y -= 8*v; break;
                //na wschód
                case 1: _x += 8*v; break;
                //na południe
                case 2: _y += 8*v; break;
                //na zachód
                case 3: _x -= 8*v; break;
            }
            int wiersz = (int)(_y / wys),
                kolumna= (int)(_x/szer);
            //nie wyjeżdzja poza planszę
            if (kolumna < 0 ||
                kolumna > ileKlatekX-1 ||
                wiersz < 0 ||
                wiersz > ileKlatekY-1) return false;
            //czy kolizja z czolgiem przeciwnika
            int wierszB = (int)(B.Y / wys),
                kolumnaB = (int)(B.X / szer);
            if(wiersz==wierszB && kolumna==kolumnaB) return false;
            //klatka o indeksie 16 jest trawą-gruntem
            //po którym można jeździć, po pozostałych nie można
            if (plansza[wiersz,kolumna]!=16)return false;
            return true;
        }
        
        public void Ruch(int[,] plansza, int ileKlatekX, int ileKlatekY,Czolg B)
        {
            if (!fRuch||
                !CzyMoznaZrobicRuch(plansza, ileKlatekX, ileKlatekY,B))
                return;
            
            switch (idKlatka){
                //na północ
                case 0:y -= v;break;
                //na wschód
                case 1: x += v; break;
                //na południe
                case 2: y += v; break;
                //na zachód
                case 3: x -= v; break;
            }
        }
        
    }
}
